using BingoBrain.Core;
using BingoBrain.HotFix;

namespace BingoBrain
{
    public class BingoHalldUICtrl : BaseUICtrl
    {
        private BingoHalldUI ui;
        private BingoHalldModel model;

        private uint openUIMsg = SkinInfo.BingoHalldUI_Open;
        private uint closeUIMsg = SkinInfo.BingoHalldUI_Close;

        #region 生命周期

        protected override void OnInit()
        {
        }

        protected override void OnDispose()
        {
        }

        public override void OpenUI(object args = null)
        {
            if (ui == null)
            {
                ui = new BingoHalldUI(this);
                ui.Open(args);
            }
        }

        public override void CloseUI(object args = null)
        {
            if (ui != null && !ui.isClose)
            {
                ui.Close();
            }

            ui = null;
        }

        #endregion

        #region 消息

        public override uint GetOpenUIMsg(string uiName)
        {
            return openUIMsg;
        }

        public override uint GetCloseUIMsg(string uiName)
        {
            return closeUIMsg;
        }

        protected override void AddListener()
        {
            uiCtrlDispatcher.AddListener(openUIMsg, OpenUI);
            uiCtrlDispatcher.AddListener(closeUIMsg, CloseUI);
            uiCtrlDispatcher.AddListener(SkinInfo.MainTabUI_Display, OnMainTabUI_Display);
        }

        protected override void RemoveListener()
        {
            uiCtrlDispatcher.RemoveListener(openUIMsg, OpenUI);
            uiCtrlDispatcher.RemoveListener(closeUIMsg, CloseUI);
            uiCtrlDispatcher.RemoveListener(SkinInfo.MainTabUI_Display, OnMainTabUI_Display);
        }

        #endregion

        private void OnMainTabUI_Display(object obj)
        {
            if (obj != null)
            {
                var isShow = (bool)obj;
                if (isShow)
                {
                    ui?.Display();
                }
                else
                {
                    ui?.Hide();
                }
            }
        }
    }
}